/*
 * kissdx - KiSS PC-Link Daemon eXtended (based on kissd)
 *
 * Copyright (C) 2005 Stelian Pop <stelian@popies.net>
 * Portions Copyright (C) 2006 Vidar Tysse <vidar@vidartysse.net>
 *
 * Heavily based on kiss4lin,
 * Copyright (C) 2004 Jacob Kolding <dacobi@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <syslog.h>

extern int a_opt, d_opt, k_opt, v_opt;

extern char audiopath[];
extern char videopath[];
extern char picturepath[];
extern char persistentstoragepath[];
extern char kmlurl[];
extern char pretrigger[];
extern char posttrigger[];
extern char audiofileextensions[];
extern char videofileextensions[];
extern char picturefileextensions[];
extern char isofileextensions[];
extern int max_recent_files;
extern char server_character_set[];
extern char client_character_set[];
extern char subtitle_catchall_pattern[];
extern int picturetargetwidth;
extern int picturetargetheight;
extern int picturemaxzoompercent;
extern int picturecachesize;
extern int picturecachetrimminginterval;
extern int networktimeoutinterval;

#define KISSD_VERSION "v0.13-8b, 2006-12-10"

enum mediastore_t {mst_unknown=0, mst_audio, mst_video, mst_picture};

extern int standard_filemode;
extern int standard_dir_filemode;

extern int is_socket_timed_out;

void handle_request(int sock);
void handle_kmlrequest(int sock);
void clean_pathname(char *path);
int do_send(int sock, char *buffer, int size);
char * extended_logfile_format(const char *format);
int get_recent_path(char *recentpath, const char *mediapath);

#define log(format, args...)					\
	do {							\
		if (d_opt)					\
			syslog(LOG_WARNING, extended_logfile_format(format), args);	\
		else						\
			fprintf(stderr, extended_logfile_format(format "\n"), args);	\
	} while(0)

#define log0(txt)					\
	do {							\
		if (d_opt)					\
			syslog(LOG_WARNING, extended_logfile_format(txt));	\
		else						\
			fprintf(stderr, extended_logfile_format(txt "\n"));	\
	} while(0)

#define logv(format, args...)					\
	do {							\
		if (v_opt) {						\
			if (d_opt)					\
				syslog(LOG_INFO, extended_logfile_format(format), args);	\
			else						\
				fprintf(stderr, extended_logfile_format(format "\n"), args);	\
		}						\
	} while(0)

#define logv0(txt)					\
	do {							\
		if (v_opt) {					\
			if (d_opt)					\
				syslog(LOG_INFO, extended_logfile_format(txt));	\
			else						\
				fprintf(stderr, extended_logfile_format(txt "\n"));	\
		}						\
	} while(0)

#define min(a, b) (((a) < (b)) ? (a) : (b))
#define max(a, b) (((a) > (b)) ? (a) : (b))
